diff --git a/src/main/java/net/minecraft/server/gui/GuiStatsComponent.java b/src/main/java/net/minecraft/server/gui/GuiStatsComponent.java
index e3d78a8dc..58cfa30c0 100644
--- a/src/main/java/net/minecraft/server/gui/GuiStatsComponent.java
+++ b/src/main/java/net/minecraft/server/gui/GuiStatsComponent.java
@@ -3,6 +3,8 @@ package net.minecraft.server.gui;
 import net.minecraft.core.net.NetworkManager;
 
 import java.awt.*;
+import java.awt.event.ActionEvent;
+import java.awt.event.ActionListener;
 import javax.swing.JComponent;
 import javax.swing.Timer;
 
@@ -11,6 +13,10 @@ import javax.swing.Timer;
 
 public class GuiStatsComponent extends JComponent
 {
+    private final int[] memoryUse;
+    private int updateCounter;
+    private final String[] displayStrings;
+
 
     public GuiStatsComponent()
     {
@@ -20,7 +26,7 @@ public class GuiStatsComponent extends JComponent
         setPreferredSize(new java.awt.Dimension(256, 196));
         setMinimumSize(new java.awt.Dimension(256, 196));
         setMaximumSize(new java.awt.Dimension(256, 196));
-        (new Timer(500, new GuiStatsListener(this))).start();
+        (new Timer(500, e -> GuiStatsComponent.update(this))).start();
         setBackground(Color.BLACK);
     }
 
@@ -28,8 +34,8 @@ public class GuiStatsComponent extends JComponent
     {
         long l = Runtime.getRuntime().totalMemory() - Runtime.getRuntime().freeMemory();
         System.gc();
-        displayStrings[0] = (new StringBuilder()).append("Memory use: ").append(l / 1024L / 1024L).append(" mb (").append((Runtime.getRuntime().freeMemory() * 100L) / Runtime.getRuntime().maxMemory()).append("% free)").toString();
-        displayStrings[1] = (new StringBuilder()).append("Threads: ").append(NetworkManager.readThreads).append(" + ").append(NetworkManager.writeThreads).toString();
+        displayStrings[0] = "Memory use: " + l / 1024L / 1024L + " mb (" + (Runtime.getRuntime().freeMemory() * 100L) / Runtime.getRuntime().maxMemory() + "% free)";
+        displayStrings[1] = "Threads: " + NetworkManager.readThreads + " + " + NetworkManager.writeThreads;
         memoryUse[updateCounter++ & 0xff] = (int)((l * 100L) / Runtime.getRuntime().maxMemory());
         repaint();
     }
@@ -62,8 +68,4 @@ public class GuiStatsComponent extends JComponent
     {
         guistatscomponent.updateStats();
     }
-
-    private int memoryUse[];
-    private int updateCounter;
-    private String displayStrings[];
 }
diff --git a/src/main/java/net/minecraft/server/gui/ServerGui.java b/src/main/java/net/minecraft/server/gui/ServerGui.java
index c785b0ea0..bc4a987eb 100644
--- a/src/main/java/net/minecraft/server/gui/ServerGui.java
+++ b/src/main/java/net/minecraft/server/gui/ServerGui.java
@@ -1,48 +1,77 @@
 package net.minecraft.server.gui;
 
-import java.awt.BorderLayout;
-import java.awt.Dimension;
+import java.awt.*;
+import java.awt.event.ActionEvent;
+import java.awt.event.ActionListener;
+import java.awt.event.FocusAdapter;
+import java.awt.event.FocusEvent;
+import java.awt.event.FocusListener;
+import java.awt.event.WindowAdapter;
+import java.awt.event.WindowEvent;
 
 import javax.swing.*;
 import javax.swing.border.EtchedBorder;
 import javax.swing.border.TitledBorder;
+import javax.swing.text.BadLocationException;
+import javax.swing.text.Document;
 
+import com.mojang.logging.LogQueues;
+import com.mojang.logging.LogUtils;
 import net.minecraft.core.net.ICommandListener;
 import net.minecraft.server.player.PlayerListBox;
-import net.minecraft.core.util.helper.JTextAreaWriter;
 import net.minecraft.server.MinecraftServer;
-import org.apache.log4j.Layout;
-import org.apache.log4j.Logger;
-import org.apache.log4j.WriterAppender;
-
-
-// Referenced classes of package net.minecraft.src:
-//            ICommandListener, ServerWindowAdapter, GuiStatsComponent, PlayerListBox, 
-//            GuiLogOutputHandler, ServerGuiCommandListener, ServerGuiFocusAdapter
+import org.slf4j.Logger;
 
 public class ServerGui extends JComponent
     implements ICommandListener
 {
 
-    public static void initGui(MinecraftServer minecraftserver)
+    public static Logger LOGGER = LogUtils.getLogger();
+    public static Font MONOSPACED = new Font("Monospaced", Font.PLAIN, 12);
+
+    private final MinecraftServer mcServer;
+    private Thread logAppenderThread;
+
+
+    public static void initGui(MinecraftServer mcServer)
     {
         try
         {
             UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
         }
-        catch(Exception exception) { }
-        ServerGui servergui = new ServerGui(minecraftserver);
+        catch(Exception exception) {
+            LOGGER.warn("Could not set UI Look and Feel!", exception);
+        }
+        ServerGui servergui = new ServerGui(mcServer);
         JFrame jframe = new JFrame("Minecraft server");
         jframe.add(servergui);
         jframe.pack();
         jframe.setLocationRelativeTo(null);
         jframe.setVisible(true);
-        jframe.addWindowListener(new ServerWindowAdapter(minecraftserver));
+        jframe.addWindowListener(new WindowAdapter() {
+            @Override
+            public void windowClosing(WindowEvent e) {
+                mcServer.initiateShutdown();
+                while(!mcServer.serverStopped)
+                {
+                    try
+                    {
+                        Thread.sleep(100L);
+                    }
+                    catch(InterruptedException ex)
+                    {
+                        LOGGER.error("Interrupt in window close!", ex);
+                    }
+                }
+                System.exit(0);
+            }
+        });
+        servergui.start();
     }
 
-    public ServerGui(MinecraftServer minecraftserver)
+    public ServerGui(MinecraftServer mcServer)
     {
-        mcServer = minecraftserver;
+        this.mcServer = mcServer;
         setPreferredSize(new Dimension(854, 480));
         setLayout(new BorderLayout());
         try
@@ -52,7 +81,7 @@ public class ServerGui extends JComponent
         }
         catch(Exception exception)
         {
-            exception.printStackTrace();
+            LOGGER.error("Error constructing ServerGUI!", exception);
         }
     }
 
@@ -68,35 +97,72 @@ public class ServerGui extends JComponent
     private JComponent getPlayerListComponent()
     {
         PlayerListBox playerlistbox = new PlayerListBox(mcServer);
-        JScrollPane jscrollpane = new JScrollPane(playerlistbox, 22, 30);
+        JScrollPane jscrollpane = new JScrollPane(playerlistbox, ScrollPaneConstants.VERTICAL_SCROLLBAR_ALWAYS, ScrollPaneConstants.HORIZONTAL_SCROLLBAR_AS_NEEDED);
         jscrollpane.setBorder(new TitledBorder(new EtchedBorder(), "Players"));
         return jscrollpane;
     }
 
-    private JComponent getLogComponent()
-    {
-        JPanel jpanel = new JPanel(new BorderLayout());
-        JTextArea jtextarea = new JTextArea();
-
-        Layout layout = logger.getAppender("stdout").getLayout();
-        WriterAppender appender = new WriterAppender(layout, new JTextAreaWriter(jtextarea));
-        logger.addAppender(appender);
-
-        JScrollPane jscrollpane = new JScrollPane(jtextarea, 22, 30);
-        jtextarea.setEditable(false);
-        JTextField jtextfield = new JTextField();
-        jtextfield.addActionListener(new ServerGuiCommandListener(this, jtextfield));
-        jtextarea.addFocusListener(new ServerGuiFocusAdapter(this));
-        jpanel.add(jscrollpane, "Center");
-        jpanel.add(jtextfield, "South");
-        jpanel.setBorder(new TitledBorder(new EtchedBorder(), "Log and chat"));
-        return jpanel;
+    private JComponent getLogComponent() {
+        final JPanel jPanel = new JPanel(new BorderLayout());
+        final JTextArea jTextArea = new JTextArea();
+
+        final JScrollPane jScrollPane = new JScrollPane(jTextArea, ScrollPaneConstants.VERTICAL_SCROLLBAR_ALWAYS, ScrollPaneConstants.HORIZONTAL_SCROLLBAR_AS_NEEDED);
+        jTextArea.setEditable(false);
+        jTextArea.setFont(MONOSPACED);
+        final JTextField jTextField = new JTextField();
+        jTextField.addActionListener(e -> {
+            String s = jTextField.getText().trim();
+            if(!s.isEmpty())
+            {
+                mcServer.addCommand(s, this);
+            }
+            jTextField.setText("");
+        });
+//        jTextArea.addFocusListener(new FocusAdapter() {});
+
+        jPanel.add(jScrollPane, "Center");
+        jPanel.add(jTextField, "South");
+        jPanel.setBorder(new TitledBorder(new EtchedBorder(), "Log and chat"));
+        this.logAppenderThread = new Thread(() -> {
+            do {
+                String logEvent = LogQueues.getNextLogEvent("ServerGuiConsole");
+                if (logEvent != null) {
+                    print(jTextArea, jScrollPane, logEvent);
+                } else {
+                    break;
+                }
+            } while (true);
+        });
+        logAppenderThread.setUncaughtExceptionHandler(new DefaultUncaughtExceptionHandler(LOGGER));
+
+        this.logAppenderThread.setDaemon(true);
+        return jPanel;
+    }
+
+    public void print(final JTextArea textArea, final JScrollPane scrollPane, final String message) {
+        if (!SwingUtilities.isEventDispatchThread()) {
+            SwingUtilities.invokeLater(() -> this.print(textArea, scrollPane, message));
+            return;
+        }
+        final Document document = textArea.getDocument();
+        final JScrollBar scrollBar = scrollPane.getVerticalScrollBar();
+        boolean scrollMax = false;
+        if (scrollPane.getViewport().getView() == textArea) {
+            scrollMax = (scrollBar.getValue() + scrollBar.getSize().getHeight() + MONOSPACED.getSize() * 4 > scrollBar.getMaximum());
+        }
+        try {
+            document.insertString(document.getLength(), message, null);
+        }
+        catch (final BadLocationException ignored) {}
+        if (scrollMax) {
+            scrollBar.setValue(Integer.MAX_VALUE);
+        }
     }
 
     @Override
-	public void log(String s)
+	public void logInfo(String s)
     {
-        logger.info(s);
+        LOGGER.info(s);
     }
 
     @Override
@@ -105,12 +171,26 @@ public class ServerGui extends JComponent
         return "CONSOLE";
     }
 
+    public void start() {
+        this.logAppenderThread.start();
+    }
+
     static MinecraftServer getMinecraftServer(ServerGui servergui)
     {
         return servergui.mcServer;
     }
 
-    public static Logger logger = Logger.getLogger("Minecraft");
-    private final MinecraftServer mcServer;
+    public static class DefaultUncaughtExceptionHandler implements Thread.UncaughtExceptionHandler
+    {
+        private final Logger logger;
+
+        public DefaultUncaughtExceptionHandler(final Logger logger) {
+            this.logger = logger;
+        }
 
+        @Override
+        public void uncaughtException(final Thread thread, final Throwable t) {
+            this.logger.error("Caught previously unhandled exception :", t);
+        }
+    }
 }
diff --git a/src/main/java/net/minecraft/server/net/ConsoleCommandHandler.java b/src/main/java/net/minecraft/server/net/ConsoleCommandHandler.java
index 03e0281b9..580f2c0ec 100644
--- a/src/main/java/net/minecraft/server/net/ConsoleCommandHandler.java
+++ b/src/main/java/net/minecraft/server/net/ConsoleCommandHandler.java
@@ -26,7 +26,7 @@ public class ConsoleCommandHandler
     }
 
     public void handleCommand(ServerCommandEntry serverCommandEntry) {
-    	System.out.println("ServerCommand: "+ serverCommandEntry.command);
+    	minecraftServer.logInfo("ServerCommand: "+ serverCommandEntry.command);
 
     	String[] args = serverCommandEntry.command.split(" ");
     	String[] args1 = new String[args.length - 1];
diff --git a/src/main/java/net/minecraft/server/net/NetworkListenThread.java b/src/main/java/net/minecraft/server/net/NetworkListenThread.java
index f781fe02f..27157a2c9 100644
--- a/src/main/java/net/minecraft/server/net/NetworkListenThread.java
+++ b/src/main/java/net/minecraft/server/net/NetworkListenThread.java
@@ -7,10 +7,11 @@ import java.net.Socket;
 import java.util.ArrayList;
 
 
+import com.mojang.logging.LogUtils;
 import net.minecraft.server.net.handler.LoginPacketHandler;
 import net.minecraft.server.net.handler.ServerPacketHandler;
 import net.minecraft.server.MinecraftServer;
-import org.apache.log4j.Logger;
+import org.slf4j.Logger;
 
 
 // Referenced classes of package net.minecraft.src:
@@ -18,8 +19,16 @@ import org.apache.log4j.Logger;
 
 public class NetworkListenThread
 {
+    private static final Logger LOGGER = LogUtils.getLogger();
+    private final ServerSocket serverSocket;
+    private final Thread networkAcceptThread;
+    public volatile boolean isListening;
+    private int connectionCounter;
+    private final ArrayList<LoginPacketHandler> pendingConnections;
+    private final ArrayList<ServerPacketHandler> playerList;
+    public MinecraftServer mcServer;
 
-    public NetworkListenThread(MinecraftServer minecraftserver, InetAddress addr, int i)
+    public NetworkListenThread(MinecraftServer minecraftserver, InetAddress address, int i)
         throws IOException
     {
         isListening = false;
@@ -27,7 +36,7 @@ public class NetworkListenThread
         pendingConnections = new ArrayList<>();
         playerList = new ArrayList<>();
         mcServer = minecraftserver;
-        serverSocket = new ServerSocket(i, 0, addr);
+        serverSocket = new ServerSocket(i, 0, address);
         serverSocket.setPerformancePreferences(0, 2, 1);
         isListening = true;
         networkAcceptThread = new Thread(() -> {
@@ -39,7 +48,7 @@ public class NetworkListenThread
                         addPendingConnection(loginHandler);
                     }
                 } catch (IOException ioexception) {
-                    ioexception.printStackTrace();
+                    LOGGER.error("Exception in network login thread!", ioexception);
                 }
             }
         });
@@ -75,7 +84,7 @@ public class NetworkListenThread
             catch(Exception exception)
             {
                 netloginhandler.kickUser("Internal server error");
-                logger.warn("Failed to handle packet: " + exception, exception);
+                LOGGER.warn("Failed to handle packet: {}", exception, exception);
             }
             if(netloginhandler.finishedProcessing)
             {
@@ -86,32 +95,22 @@ public class NetworkListenThread
 
         for(int j = 0; j < playerList.size(); j++)
         {
-            ServerPacketHandler netserverhandler = (ServerPacketHandler)playerList.get(j);
+            ServerPacketHandler serverPacketHandler = playerList.get(j);
             try
             {
-                netserverhandler.handlePackets();
+                serverPacketHandler.handlePackets();
             }
             catch(Exception exception1)
             {
-                logger.warn("Failed to handle packet: " + exception1, exception1);
-                netserverhandler.kickPlayer("Internal server error");
+                LOGGER.warn("Failed to handle packet: {}", exception1, exception1);
+                serverPacketHandler.kickPlayer("Internal server error");
             }
-            if(netserverhandler.connectionClosed)
+            if(serverPacketHandler.connectionClosed)
             {
                 playerList.remove(j--);
             }
-            netserverhandler.netManager.wakeThreads();
+            serverPacketHandler.netManager.wakeThreads();
         }
 
     }
-
-    public static Logger logger = Logger.getLogger("Minecraft");
-    private ServerSocket serverSocket;
-    private Thread networkAcceptThread;
-    public volatile boolean isListening;
-    private int connectionCounter;
-    private ArrayList<LoginPacketHandler> pendingConnections;
-    private final ArrayList<ServerPacketHandler> playerList;
-    public MinecraftServer mcServer;
-
 }
